<!-- This comment will put IE 6, 7 and 8 in quirks mode -->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>TIOVX User Guide: vx_reference.h File Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javaScript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<img src="ti_logo.gif">
<tr bgcolor="#CCCCCC"> 
      <td bgcolor="#FFFFFF">
        <hr align="left" noshade size="1">
      </td>
</tr>
<!-- Generated by Doxygen 1.6.1 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="main.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
    </ul>
  </div>
</div>
<div class="contents">
<h1>vx_reference.h File Reference</h1><hr/><a name="_details"></a><h2>Introduction</h2>
<p>Implementation of Reference object. </p>

<p><a href="vx__reference_8h_source.html">Go to the source code of this file.</a></p>
<table border="0" cellpadding="0" cellspacing="0">
<tr><td colspan="2"><h2>Data Structures</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">struct &nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structtivx__reference__t.html">tivx_reference_t</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">The most basic type in the OpenVX system. Any type that inherits from <a class="el" href="structtivx__reference__t.html" title="The most basic type in the OpenVX system. Any type that inherits from tivx_reference_t...">tivx_reference_t</a> must have a vx_reference_t as its first memeber to allow casting to this type.  <a href="structtivx__reference__t.html#_details">More...</a><br/></td></tr>
<tr><td colspan="2"><h2>Typedefs</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef <a class="el" href="vx__types_8h.html#a64df90a05ff50c048d65ab77bc60e4f0">vx_status</a>(*&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__group__vx__reference.html#ga8e985f6c4f883699f2b91dae32f95c8b">tivx_reference_callback_f</a> )(<a class="el" href="vx__types_8h.html#a1a95c3bf180e49d4d1ecd64cb35f45a3">vx_reference</a> ref)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Callback type used to register different callbacks from object dervied from references.  <a href="group__group__vx__reference.html#ga8e985f6c4f883699f2b91dae32f95c8b"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef <a class="el" href="vx__types_8h.html#a64df90a05ff50c048d65ab77bc60e4f0">vx_status</a>(*&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__group__vx__reference.html#gad1343c102ae5c3085acc4fcd86d1ebb7">VX_API_CALL</a> )(<a class="el" href="vx__types_8h.html#a1a95c3bf180e49d4d1ecd64cb35f45a3">vx_reference</a> *ref)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Callback type used to register release callbacks from object dervied from references.  <a href="group__group__vx__reference.html#gad1343c102ae5c3085acc4fcd86d1ebb7"></a><br/></td></tr>
<tr><td colspan="2"><h2>Enumerations</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">enum &nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__group__vx__reference.html#gacd45d0c17bdc4c34ffc0c1c00c000617">tivx_reftype_e</a> { <a class="el" href="group__group__vx__reference.html#ggacd45d0c17bdc4c34ffc0c1c00c000617a2dcb643ac40c572517e64e34a936f2bb">VX_INTERNAL</a> =  1, 
<a class="el" href="group__group__vx__reference.html#ggacd45d0c17bdc4c34ffc0c1c00c000617a8625931f75a452b1522c56c4efa859ab">VX_EXTERNAL</a> =  2, 
<a class="el" href="group__group__vx__reference.html#ggacd45d0c17bdc4c34ffc0c1c00c000617ab955e8dc192ab3f60269b09d3d83398c">VX_BOTH</a> =  3
 }</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight"><p>An internal enum for notating which sort of reference type we need. </p>
 <a href="group__group__vx__reference.html#gacd45d0c17bdc4c34ffc0c1c00c000617">More...</a><br/></td></tr>
<tr><td colspan="2"><h2>Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="vx__types_8h.html#a1a95c3bf180e49d4d1ecd64cb35f45a3">vx_reference</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__group__vx__reference.html#ga4de1be80a5e70c18cd1b6a0693fbdb47">ownCreateReference</a> (<a class="el" href="vx__types_8h.html#a0f4f894d935fbf50bf38b3529a001249">vx_context</a> context, <a class="el" href="vx__types_8h.html#a73d23cb932d31a69f44182054a987c85">vx_enum</a> type, <a class="el" href="vx__types_8h.html#a73d23cb932d31a69f44182054a987c85">vx_enum</a> reftype, <a class="el" href="vx__types_8h.html#a1a95c3bf180e49d4d1ecd64cb35f45a3">vx_reference</a> scope)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Create a reference object.  <a href="group__group__vx__reference.html#ga4de1be80a5e70c18cd1b6a0693fbdb47"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="vx__types_8h.html#a64df90a05ff50c048d65ab77bc60e4f0">vx_status</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__group__vx__reference.html#gac3ad1447b01e8ce0806adfa8447590c3">ownReleaseReferenceInt</a> (<a class="el" href="vx__types_8h.html#a1a95c3bf180e49d4d1ecd64cb35f45a3">vx_reference</a> *ref, <a class="el" href="vx__types_8h.html#a73d23cb932d31a69f44182054a987c85">vx_enum</a> type, <a class="el" href="vx__types_8h.html#a73d23cb932d31a69f44182054a987c85">vx_enum</a> reftype, <a class="el" href="group__group__vx__reference.html#ga8e985f6c4f883699f2b91dae32f95c8b">tivx_reference_callback_f</a> destructor)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Used to destroy a reference.  <a href="group__group__vx__reference.html#gac3ad1447b01e8ce0806adfa8447590c3"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="vx__types_8h.html#a7ab7c7864a0ea6762a9e15be80ef28f0">vx_bool</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__group__vx__reference.html#gab8dc3b7c601b6cb800b5194f35facb08">ownIsValidSpecificReference</a> (<a class="el" href="vx__types_8h.html#a1a95c3bf180e49d4d1ecd64cb35f45a3">vx_reference</a> ref, <a class="el" href="vx__types_8h.html#a73d23cb932d31a69f44182054a987c85">vx_enum</a> type)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Used to validate everything but vx_context, vx_image.  <a href="group__group__vx__reference.html#gab8dc3b7c601b6cb800b5194f35facb08"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="vx__types_8h.html#a64df90a05ff50c048d65ab77bc60e4f0">vx_status</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__group__vx__reference.html#ga46261af73a663a9ced354739f57100d1">ownReferenceLock</a> (<a class="el" href="vx__types_8h.html#a1a95c3bf180e49d4d1ecd64cb35f45a3">vx_reference</a> ref)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Lock the reference.  <a href="group__group__vx__reference.html#ga46261af73a663a9ced354739f57100d1"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="vx__types_8h.html#a64df90a05ff50c048d65ab77bc60e4f0">vx_status</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__group__vx__reference.html#gaecb8495533f11379e448b826a0bcdbf3">ownReferenceUnlock</a> (<a class="el" href="vx__types_8h.html#a1a95c3bf180e49d4d1ecd64cb35f45a3">vx_reference</a> ref)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Unlock the reference.  <a href="group__group__vx__reference.html#gaecb8495533f11379e448b826a0bcdbf3"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="vx__types_8h.html#a1ddb983b9696cafdb4256c0df757171c">vx_uint32</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__group__vx__reference.html#ga8a250ea2cd1c516ba57798a360de4bc1">ownIncrementReference</a> (<a class="el" href="vx__types_8h.html#a1a95c3bf180e49d4d1ecd64cb35f45a3">vx_reference</a> ref, <a class="el" href="vx__types_8h.html#a73d23cb932d31a69f44182054a987c85">vx_enum</a> reftype)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Increments the ref count.  <a href="group__group__vx__reference.html#ga8a250ea2cd1c516ba57798a360de4bc1"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="vx__types_8h.html#a1ddb983b9696cafdb4256c0df757171c">vx_uint32</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__group__vx__reference.html#gac4bd5051397559d84a544f09de52191c">ownDecrementReference</a> (<a class="el" href="vx__types_8h.html#a1a95c3bf180e49d4d1ecd64cb35f45a3">vx_reference</a> ref, <a class="el" href="vx__types_8h.html#a73d23cb932d31a69f44182054a987c85">vx_enum</a> reftype)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Decrements the ref count.  <a href="group__group__vx__reference.html#gac4bd5051397559d84a544f09de52191c"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="vx__types_8h.html#a1ddb983b9696cafdb4256c0df757171c">vx_uint32</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__group__vx__reference.html#gabf65108598010b9690afdbc4893fb36c">ownTotalReferenceCount</a> (<a class="el" href="vx__types_8h.html#a1a95c3bf180e49d4d1ecd64cb35f45a3">vx_reference</a> ref)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns the total reference count of the object.  <a href="group__group__vx__reference.html#gabf65108598010b9690afdbc4893fb36c"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__group__vx__reference.html#gad786153df931e4dceafba594c6bb0d3b">ownPrintReference</a> (<a class="el" href="vx__types_8h.html#a1a95c3bf180e49d4d1ecd64cb35f45a3">vx_reference</a> ref)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Print reference information.  <a href="group__group__vx__reference.html#gad786153df931e4dceafba594c6bb0d3b"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="vx__types_8h.html#a7ab7c7864a0ea6762a9e15be80ef28f0">vx_bool</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__group__vx__reference.html#ga7b73cbb59de6fb75e986948c92b399e1">ownIsValidType</a> (<a class="el" href="vx__types_8h.html#a73d23cb932d31a69f44182054a987c85">vx_enum</a> type)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">This returns true if the type is within the definition of types in OpenVX.  <a href="group__group__vx__reference.html#ga7b73cbb59de6fb75e986948c92b399e1"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="vx__types_8h.html#a64df90a05ff50c048d65ab77bc60e4f0">vx_status</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__group__vx__reference.html#ga9ce862d27a2efc3e6ab316f0f5ce166f">ownInitReference</a> (<a class="el" href="vx__types_8h.html#a1a95c3bf180e49d4d1ecd64cb35f45a3">vx_reference</a> ref, <a class="el" href="vx__types_8h.html#a0f4f894d935fbf50bf38b3529a001249">vx_context</a> context, <a class="el" href="vx__types_8h.html#a73d23cb932d31a69f44182054a987c85">vx_enum</a> type, <a class="el" href="vx__types_8h.html#a1a95c3bf180e49d4d1ecd64cb35f45a3">vx_reference</a> scope)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Init a reference object.  <a href="group__group__vx__reference.html#ga9ce862d27a2efc3e6ab316f0f5ce166f"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="vx__types_8h.html#a7ab7c7864a0ea6762a9e15be80ef28f0">vx_bool</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__group__vx__reference.html#gaa07eb506d2b93ac98c0713861dc93c53">ownIsValidReference</a> (<a class="el" href="vx__types_8h.html#a1a95c3bf180e49d4d1ecd64cb35f45a3">vx_reference</a> ref)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Check if reference is valid.  <a href="group__group__vx__reference.html#gaa07eb506d2b93ac98c0713861dc93c53"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__group__vx__reference.html#gaa2473ba58425fd73de7e9269f694a149">ownInitReferenceForDelay</a> (<a class="el" href="vx__types_8h.html#a1a95c3bf180e49d4d1ecd64cb35f45a3">vx_reference</a> ref, <a class="el" href="vx__types_8h.html#a2c6de63476aff4a009bac8d0eb9800d1">vx_delay</a> d, <a class="el" href="vx__types_8h.html#a822fc495cb9045d45893eed297d48737">vx_int32</a> index)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Used to initialize any vx_reference as a delay element.  <a href="group__group__vx__reference.html#gaa2473ba58425fd73de7e9269f694a149"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="vx__types_8h.html#a64df90a05ff50c048d65ab77bc60e4f0">vx_status</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__group__vx__reference.html#gad42635678483ae9c930688bb56b9cf90">ownReferenceAllocMem</a> (<a class="el" href="vx__types_8h.html#a1a95c3bf180e49d4d1ecd64cb35f45a3">vx_reference</a> ref)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Alloc memory associated with this reference, typically data reference.  <a href="group__group__vx__reference.html#gad42635678483ae9c930688bb56b9cf90"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="vx__types_8h.html#a46d89d47ad9a2de1de723d0db861d324">vx_size</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__group__vx__reference.html#ga8a824924e3547a69b56d03d93d6faab8">ownSizeOfEnumType</a> (<a class="el" href="vx__types_8h.html#a73d23cb932d31a69f44182054a987c85">vx_enum</a> item_type)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Get the size of the Type enum.  <a href="group__group__vx__reference.html#ga8a824924e3547a69b56d03d93d6faab8"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__group__vx__reference.html#ga6290c7e47db2bb4c7451a59e68b6dc2d">ownReferenceSetScope</a> (<a class="el" href="vx__types_8h.html#a1a95c3bf180e49d4d1ecd64cb35f45a3">vx_reference</a> ref, <a class="el" href="vx__types_8h.html#a1a95c3bf180e49d4d1ecd64cb35f45a3">vx_reference</a> scope)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Set scope of a reference.  <a href="group__group__vx__reference.html#ga6290c7e47db2bb4c7451a59e68b6dc2d"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="vx__types_8h.html#a1a95c3bf180e49d4d1ecd64cb35f45a3">vx_reference</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__group__vx__reference.html#ga8bcc2ede5b5fbb5370ea129ff215c2aa">ownCreateReferenceFromExemplar</a> (<a class="el" href="vx__types_8h.html#a0f4f894d935fbf50bf38b3529a001249">vx_context</a> context, <a class="el" href="vx__types_8h.html#a1a95c3bf180e49d4d1ecd64cb35f45a3">vx_reference</a> exemplar)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Create reference from a exemplar object.  <a href="group__group__vx__reference.html#ga8bcc2ede5b5fbb5370ea129ff215c2aa"></a><br/></td></tr>
</table>
</div>

<html>
<table bordercolor="#FFFFFF" bgcolor="#FFFFFF" width="100%">
<tr bgcolor="#CCCCCC">
      <td bgcolor="#FFFFFF">
        <hr align="left" noshade size="1">
      </td>
</tr>
<tr bgcolor="#CCCCCC">
      <td bgcolor="#FFFFFF"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" color="#000000"><b><i>
        &copy Copyright 2017 Texas Instruments Incorporated. All rights reserved. </i></b></font></td>
</tr>
<tr bgcolor="#CCCCCC">
      <td bgcolor="#FFFFFF"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" color="#000000">
        Document generated by <b><i> doxygen </i></b> 1.6.1
  </font></td>
</tr>
</table>
